% Example of LP2NN with proposed kill-switch to deactivate neurons

clear all;
run('/prog/gurobi/linux64/matlab/gurobi_setup');

%note: the time is set to 150 sec. so you might obtain a suboptimal
%solution
%the results also depend on the shuffeling train/test 

%just uncomment/comment the database you want to use

%iris dataset
% load fisheriris;
% X=meas;
% grp=species;

%zoo dataset
zoo=load('./zoo.dat');
X=zoo(:,1:end-1);
Y=zoo(:,end);
grp=Y;

%wine dataset
%   winetemp=load('./wine.mat');
%   wine=winetemp.A;
%   X=wine(:,1:end-1);
%   Y=wine(:,end);
%   grp=Y;

  %breatEW dataset
%  btemp=load('./breastEW.mat');
%  breastEW=btemp.data;
%  X=breastEW;
%  Y=btemp.labels;
%  grp=Y;
 
 

%Normalize
X=X-min(X);
X=X./(max(X));

allErr=[];

data=X;


gcat=categorical(grp);
catg=categories(gcat)
Y=zeros(size(gcat,1),size(catg,1));
for i=1:size(Y,2)
    indx=find(gcat==catg(i));
    Y(indx,i)=1;
end

sel=randperm(size(Y,1));

%Amount of possible perceptrons
numNeurons=6

%select half of the points for training and half for testing
numPoints=floor(size(Y,1)/2);

selV=randperm(size(Y,1));
sel=selV(1:numPoints);


hiddenDim=[numNeurons];

dataTrain=data(sel,:);
YTrain=Y(sel,:);

outputDim=size(Y,2);
inputDim=size(data,2);
%  tic
[variables,Lvariables,  Aeq, beq, A, b, f, AllIntInd,LearnIntInd]=generateEquationsSN(hiddenDim,dataTrain(:,:),YTrain(:,:) );
%  toc

%Make Variable numbers for easier access later ...
N=size(Lvariables,2);
% create variables for indexing
for v = 1:N
    eval([Lvariables{v},' = ', num2str(v),';']);
end

%This is to enforce sparsity of the neurons. uncomment to skip this part
%enforce sparse variables
K=1;
for j=1:hiddenDim(K)
    Av=zeros(size(f));
    for i=1:inputDim
        st=['w'  num2str(K) 'P' num2str(i) 'H' num2str(j)];
        Av(eval(st))=1;
    end
    
    A=cat(1,A,Av);
    bv=6;
    b=cat(1,b,bv);
end

fN=f;

lb = zeros(size(fN,2),1);
ub = zeros(size(fN,2),1);

lb(:)=-5;
ub(:)=5;
lb(AllIntInd)=0;
ub(AllIntInd)=1;
intVar=[AllIntInd];

intVar=[AllIntInd];
for I=1:inputDim
    for j=1:hiddenDim(K)
        st=['w'  num2str(K) 'P' num2str(I) 'H' num2str(j)];
        intVar=[intVar eval(st)];
        lb(eval(st))=0;
        ub(eval(st))=5;
    end
end

x0=zeros(size(f));

conIter=1; 

times=[1500] ;
for resG=1:size(times,2)
    
    
    options = optimoptions('intlinprog','MaxTime',times(resG),'Display','none');
    if(conIter==1)
        
        %This for matlab but far less efficient
        %[xRes,fval] = intlinprog(fN,intVar,A,b,Aeq,beq,lb,ub,options);
        
        model.obj=fN;
        model.A=[sparse(A);sparse(Aeq)];
        n=size(model.A,2);
        model.vtype=repmat('C',n,1);
        model.sense=[repmat('<',size(A,1),1);repmat('=',size(Aeq,1),1)];
        model.rhs=full([b(:);beq(:)]);
        model.lb=lb;
        model.ub=ub;
        model.vtype(intVar)='I';
        
        params=struct();
        %params.OutputFlag=0;
        params.TimeLimit=times(resG);
        
        tic
        result=gurobi(model,params);
        toc
        
        
        
        % if(size(xRes,1)>0)  %<- this for the matlab solver
        if(exist('result') &&  isfield(result , 'x'))
            xRes=result.x;
            %Check Training data
           dataTest=data(selV(1:numPoints),:);
            YTest=Y(selV(1:numPoints),:);
            [TrainEr, omega]=testResult(xRes, hiddenDim, dataTest, YTest, Lvariables,inputDim, outputDim,LearnIntInd);      
           %check remaining data
            dataTest=data(selV(numPoints+1:end),:);
            YTest=Y(selV(numPoints+1:end),:);
            
             [TestEr, omega]=testResult(xRes, hiddenDim, dataTest, YTest, Lvariables,inputDim, outputDim,LearnIntInd);
         
             %Get the selected perceptrons
            SelPercep=[];
            for K=1:size(hiddenDim,2)
                for i=1:hiddenDim(K)
                    st=['GS'  num2str(K) 'F' num2str(i)];  %Perceptron select on/off
                    SelPercep(K,i)=xRes(eval(st));
                end
            end       
            PercUsed=sum(sum(SelPercep));
        end
    end
end

%Training Error / Testing error / amound of used neurons
[TrainEr TestEr PercUsed]
%Show the weights of the neurons ...
figure(1)
plot(omega');
            

