%make use of gating network
function [variables,Lvariables, Aeq, beq, A, b, f, AllIntInd, LearnIntInd]=generateEquationsSN(hiddenDim, data,Y )


%Lvariables contains the learnable parameters for the network weights,
%variables also the slack variables ...

outputDim=size(Y,2);
inputDim=size(data,2);

numPoints=size(Y,1);

variables={};
Lvariables={};
LearnIntInd=[];
%Find integer Variables (all Step Functions)
AllIntInd=[];


%Only weights for K=1
K=1;
count=1;
for i=1:inputDim%hiddenDim(K)
    for j=1:hiddenDim(K)
        st=['w'  num2str(K) 'P' num2str(i) 'H' num2str(j)];
        variables{end+1}=st;
        Lvariables{end+1}=st;
        LearnIntInd(end+1)=count;
        count=count+1;
       
    end
end
%end

for K=1:size(hiddenDim,2)-1
    for i=1:hiddenDim(K)
        for j=1:hiddenDim(K+1)
            st=['wH'  num2str(K) 'P' num2str(i) 'H' num2str(j)];
            variables{end+1}=st;Lvariables{end+1}=st;
            LearnIntInd(end+1)=count;
        count=count+1;
      
        end
    end
end

for K=1:size(hiddenDim,2)
    for i=1:hiddenDim(K)
        st=['GS'  num2str(K) 'F' num2str(i)];  %Perceptron select on/off
          variables{end+1}=st;Lvariables{end+1}=st;
            AllIntInd(end+1)=size(variables,2);
          LearnIntInd(end+1)=count;
        count=count+1;
        
    end
end

%bias
for K=1:size(hiddenDim,2)
    for j=1:hiddenDim(K)
        st=['bH' num2str(K) 'P' num2str(j)];
        variables{end+1}=st;Lvariables{end+1}=st;
        LearnIntInd(end+1)=count;
        count=count+1;
    end
end

%weight outputLayer "Final"
for j=1:hiddenDim(end)
    for k=1:outputDim
        st=['F' num2str(j) 'O' num2str(k)];
        variables{end+1}=st;Lvariables{end+1}=st;
        LearnIntInd(end+1)=count;
        count=count+1;
%         st=['GSF'  num2str(j) 'T' num2str(k)];  %Gate Switch value From to
%           variables{end+1}=st;
%           LearnIntInd(end+1)=count;
%            AllIntInd(end+1)=size(variables,2);
%            
        count=count+1;
    end
end

%OutBias bF
for i=1:outputDim
    st=['bF' num2str(i)];
    variables{end+1}=st;Lvariables{end+1}=st;
    LearnIntInd(end+1)=count;
        count=count+1;
end

%Result Variables
for i=1:numPoints
    for j=1:outputDim
        st=['GT' num2str(i) 'O' num2str(j)];
        variables{end+1}=st;Lvariables{end+1}=st;
    end
end

%Slack Variables
for i=1:numPoints
    variablesO={};
    %ScalarProdukt
    for K=1:size(hiddenDim,2)
        for j=1:hiddenDim(K)
            st=['SlF' num2str(K) 'P' num2str(i) 'SP' num2str(j)];
            variablesO{end+1}=st;
        end
    end
    
    %All StepFunctions
    for K=1:size(hiddenDim,2)
        for j=1:hiddenDim(K)
            st=['SlFL' num2str(K) 'P' num2str(i) 'ST' num2str(j)];
            variablesO{end+1}=st;
                      
        end
    end
    
    %All Hidden Layers Pass/Step Functions
    for K=1:size(hiddenDim,2)-1
        for I=1:hiddenDim(K)
            for j=1:hiddenDim(K+1)
                st=['SlL' num2str(K) 'P' num2str(i) 'Pass' num2str(I) 'O' num2str(j) ];
                variablesO{end+1}=st;
               
                  st=['SlL' num2str(K) 'P' num2str(i) 'PassSel' num2str(I) 'O' num2str(j) ];
                variablesO{end+1}=st;
              
            end
        end
    end
    
   
    %PassFunction to outputLayer
    for j=1:hiddenDim(end)
        for k=1:outputDim
            st=['SlF' num2str(i) 'Pass' num2str(j) 'O' num2str(k) ];
            variablesO{end+1}=st;        
             st2S=['SlFSel' num2str(i) 'Pass' num2str(j) 'O' num2str(k) ];
             variablesO{end+1}=st2S;
        end
    end
    
    %Decision Layer
    for j=1:outputDim
        st=['SlF' num2str(i) 'SPF' num2str(j)];
        variablesO{end+1}=st;
        st=['SlF' num2str(i) 'STF' num2str(j)];
        variablesO{end+1}=st;
    end
    variables=cat(2,variables,variablesO);
end

variables;

%Make Variable numbers for easier access later ...
N=size(variables,2);
% create variables for indexing
for v = 1:N
    eval([variables{v},' = ', num2str(v),';']);
end

f=zeros(1,N);
%Locate the optimization variables
for i=1:numPoints
    for k=1:outputDim
        st=['GT' num2str(i) 'O' num2str(k)];
        f(eval(st))=1;
    end
end

%Set value to 0 to avoid kill switch ...
%minimize the used perceptrons
for K=1:size(hiddenDim,2)
    for i=1:hiddenDim(K)
        st=['GS'  num2str(K) 'F' num2str(i)];  %Perceptron select on/off
         f(eval(st))= 0.1;     %set to zero to not penalize extra kill switch     
    end
end



for i=1:numPoints
    for K=1:size(hiddenDim,2)
        for j=1:hiddenDim(K)
            st=['SlFL' num2str(K) 'P' num2str(i) 'ST' num2str(j)];
            AllIntInd(end+1)=eval(st);
        end
    end
end


for i=1:numPoints
    for j=1:outputDim
        st=['SlF' num2str(i) 'STF' num2str(j)];
        AllIntInd(end+1)=eval(st);
        st=['GT' num2str(i) 'O' num2str(j)];
        AllIntInd(end+1)=eval(st);
    end
end

Aeq=sparse([]); % eq: equality constraints !
beq=sparse([]);
A=sparse([]);
b=sparse([]);

for I=1:numPoints
    
    AeqT=sparse([]);
    beqT=sparse([]);
    AT=sparse([]);
    bT=sparse([]);
    %scalar products of first Layer
    K=1;
    for j=1:hiddenDim(K)
        Av=zeros(size(f));
        for i=1:inputDim
            st=['w'  num2str(K) 'P' num2str(i) 'H' num2str(j)];
            Av(eval(st))=data(I,i);
        end
        st=['bH' num2str(K) 'P' num2str(j)];
        Av(eval(st))=1;
        st=['SlF' num2str(K) 'P' num2str(I) 'SP' num2str(j)];
        Av(eval(st))=-1;
        AeqT=cat(1,AeqT,Av);
        bv=0;
        beqT=cat(1,beqT,bv);
        
    end
 
    %Now we go across all Hidden Layers         
    for K=1:size(hiddenDim,2)-1
        
        %Step Function of Layer K
        for j=1:hiddenDim(K)
            st1=['SlF' num2str(K) 'P' num2str(I) 'SP' num2str(j)];
            st2=['SlFL' num2str(K) 'P' num2str(I) 'ST' num2str(j)];
            [Av bv]=StepFunction(eval(st1),eval(st2),size(f,2));
            AT=cat(1,AT,Av);
            bT=cat(1,bT,bv);
        end
        
        Av=zeros(size(f));
        for j=1:hiddenDim(K)
            st2=['SlFL' num2str(K) 'P' num2str(I) 'ST' num2str(j)];
            Av(1,eval(st))=-1;
        end
        bv=-1;
        AT=cat(1,AT,Av);
        bT=cat(1,bT,bv);
        
      %Pass Function of Layer K to K+1
        for i=1:hiddenDim(K)
            st1=['SlFL' num2str(K) 'P' num2str(I) 'ST' num2str(i)];
            
            %stS=['GS'  num2str(K) 'F' num2str(i) 'T' num2str(i)];  %Perceptron select on/
            stS=['GS'  num2str(K) 'F' num2str(i)];  %Perceptron select on/off
           
            for j=1:hiddenDim(K+1)
                st2=['SlL' num2str(K) 'P' num2str(I) 'Pass' num2str(i) 'O' num2str(j) ]; %Pass Res
                 st2S=['SlL' num2str(K) 'P' num2str(I) 'PassSel' num2str(i) 'O' num2str(j) ];             
                st3=['wH'  num2str(K) 'P' num2str(i) 'H' num2str(j)];              
                [Av bv]=PassFunction(eval(st1),eval(st3) ,eval(st2), size(f,2));
                AT=cat(1,AT,Av);
                bT=cat(1,bT,bv);
                
                  [Av bv]=PassFunction(eval(stS),eval(st2) ,eval(st2S), size(f,2));
                AT=cat(1,AT,Av);
                bT=cat(1,bT,bv);
                 
            end
        end
        
        %Scalar product for the next layer       
        for j=1:hiddenDim(K+1)
            %scalar product + finale Bias
            Av=zeros(size(f));
            for i=1:hiddenDim(K)
                %st=['SlL' num2str(K) 'P' num2str(I) 'Pass' num2str(i) 'O' num2str(j) ]; %Pass Res
                st=['SlL' num2str(K) 'P' num2str(I) 'PassSel' num2str(i) 'O' num2str(j) ];
             
                Av(1,eval(st))=1;
            end
            st=['bH' num2str(K+1) 'P' num2str(j)];
            Av(1,eval(st))=1;
            st=['SlF' num2str(K+1) 'P' num2str(I) 'SP' num2str(j)];         
            Av(1,eval(st))=-1;
            bv=0;
            AeqT=cat(1,AeqT,Av);
            beqT=cat(1,beqT,bv);
            
        end
    end
    
    %Passfunction for the last hidden Neurons to the output Layer
    K=size(hiddenDim,2) ;
    for j=1:hiddenDim(K)
        st1=['SlF' num2str(K) 'P' num2str(I) 'SP' num2str(j)];
        st2=['SlFL' num2str(K) 'P' num2str(I) 'ST' num2str(j)];
        [Av bv]=StepFunction(eval(st1),eval(st2),size(f,2));
        AT=cat(1,AT,Av);
        bT=cat(1,bT,bv);
    end
   
    for j=1:hiddenDim(K)
        st1=['SlFL' num2str(K) 'P' num2str(I) 'ST' num2str(j)];  
        stS=['GS'  num2str(K) 'F' num2str(j)];  %Perceptron select on/off
           
        for k=1:outputDim
            st2=['SlF' num2str(I) 'Pass' num2str(j) 'O' num2str(k) ];
            
            st3=['F' num2str(j) 'O' num2str(k)];
            
             st2S=['SlFSel' num2str(I) 'Pass' num2str(j) 'O' num2str(k) ];
           
         
            [Av bv]=PassFunction(eval(st1),eval(st3) ,eval(st2), size(f,2));
            AT=cat(1,AT,Av);
            bT=cat(1,bT,bv);
            
            [Av bv]=PassFunction(eval(stS),eval(st2) ,eval(st2S), size(f,2));
             AT=cat(1,AT,Av);
             bT=cat(1,bT,bv);  
            
            
               
        end
    end
    
    for k=1:outputDim
        %scalar product + finale Bias
        Av=zeros(size(f));
        for j=1:hiddenDim(K)
            % st1=['SlF' num2str(I) 'Pass' num2str(j)];
            %st1=['SlF' num2str(I) 'Pass' num2str(j) 'O' num2str(k) ];     
            st1=['SlFSel' num2str(I) 'Pass' num2str(j) 'O' num2str(k) ];
            Av(1,eval(st1))=1;
        end
        st=['bF' num2str(k)];
        Av(1,eval(st))=1;
        st=['SlF' num2str(I) 'SPF' num2str(k)];
        Av(1,eval(st))=-1;
        bv=0;
        AeqT=cat(1,AeqT,Av);
        beqT=cat(1,beqT,bv);
    end
    
    for k=1:outputDim
        %Step Function
        st1=['SlF' num2str(I) 'SPF'  num2str(k)];
        st=['SlF' num2str(I) 'STF'  num2str(k)];
        [Av bv]=StepFunction(eval(st1),eval(st),size(f,2));
        AT=cat(1,AT,Av);
        bT=cat(1,bT,bv);
    end
     
     for k=1:outputDim
           Av=zeros(size(f));
          stS=['SlF' num2str(I) 'STF' num2str(k)];
           stF=['GT' num2str(I) 'O' num2str(k)]; %slack variable
          if(Y(I,k)==1)
             Av(1,eval(stS))=1;
              Av(1,eval(stF))=1;
             bV=1;     
           AeqT=cat(1,AeqT,Av);
           beqT=cat(1,beqT,bV);
          else
             Av(1,eval(stS))=1;
             Av(1,eval(stF))=-1; 
             bV=0;      
           AeqT=cat(1,AeqT,Av);
           beqT=cat(1,beqT,bV);          
          end
     end

    A=cat(1,A,sparse(AT));
    b=cat(1,b,sparse(bT));
    Aeq=cat(1,Aeq,sparse(AeqT));
    beq=cat(1,beq,sparse(beqT));
end



end